#ifndef _VBIDE_HPP_INCLUDED
#define _VBIDE_HPP_INCLUDED

#pragma warning 849 9 // "Warning! base class virtual function has not been overriden"
#include "wstdtype.hpp"
#include "Office97.hpp"
#include "VBIDEUser97.hpp"

#ifdef __OPTIMA_USE_COMPONENT_LIBRARIES__
#  pragma library ("VBIDE.lib")
#endif // __OPTIMA_USE_COMPONENT_LIBRARIES__

typedef long vbext_WindowType;
#define vbext_WindowTypevbext_wt_CodeWindow 0
#define vbext_WindowTypevbext_wt_Designer 1
#define vbext_WindowTypevbext_wt_Browser 2
#define vbext_WindowTypevbext_wt_Watch 3
#define vbext_WindowTypevbext_wt_Locals 4
#define vbext_WindowTypevbext_wt_Immediate 5
#define vbext_WindowTypevbext_wt_ProjectWindow 6
#define vbext_WindowTypevbext_wt_PropertyWindow 7
#define vbext_WindowTypevbext_wt_Find 8
#define vbext_WindowTypevbext_wt_FindReplace 9
#define vbext_WindowTypevbext_wt_LinkedWindowFrame 11
#define vbext_WindowTypevbext_wt_MainWindow 12
#define vbext_WindowTypevbext_wt_ToolWindow 15

typedef long vbext_WindowState;
#define vbext_WindowStatevbext_ws_Normal 0
#define vbext_WindowStatevbext_ws_Minimize 1
#define vbext_WindowStatevbext_ws_Maximize 2

typedef long vbext_ProjectProtection;
#define vbext_ProjectProtectionvbext_pp_none 0
#define vbext_ProjectProtectionvbext_pp_locked 1

typedef long vbext_VBAMode;
#define vbext_VBAModevbext_vm_Run 0
#define vbext_VBAModevbext_vm_Break 1
#define vbext_VBAModevbext_vm_Design 2

typedef long vbext_ComponentType;
#define vbext_ComponentTypevbext_ct_StdModule 1
#define vbext_ComponentTypevbext_ct_ClassModule 2
#define vbext_ComponentTypevbext_ct_MSForm 3
#define vbext_ComponentTypevbext_ct_Document 100

typedef long vbext_ProcKind;
#define vbext_ProcKindvbext_pk_Proc 0
#define vbext_ProcKindvbext_pk_Let 1
#define vbext_ProcKindvbext_pk_Set 2
#define vbext_ProcKindvbext_pk_Get 3

typedef long vbext_CodePaneview;
#define vbext_CodePaneviewvbext_cv_ProcedureView 0
#define vbext_CodePaneviewvbext_cv_FullModuleView 1

typedef long vbext_RefKind;
#define vbext_RefKindvbext_rk_TypeLib 0
#define vbext_RefKindvbext_rk_Project 1

class _DualApplication;
class _Application;
class _DualVBE;
class _VBE;
class _DualWindow;
class _Window;
class _Dual_Windows;
class __Windows;
class Windows;
class _Dual_LinkedWindows;
class __LinkedWindows;
class LinkedWindows;
class _DualEvents;
class _Events;
class _VBProjectsEvents;
class __dispVBProjectsEvents;
class _VBComponentsEvents;
class __dispVBComponentsEvents;
class _ReferencesEvents;
class ReferencesEvents;
class _CommandBarControlEvents;
class CommandBarEvents;
class _Dual_VBProject;
class __VBProject;
class VBProject;
class _Dual_VBProjects;
class __VBProjects;
class VBProjects;
class _Dual_VBComponents;
class __VBComponents;
class VBComponents;
class _Dual_VBComponent;
class __VBComponent;
class VBComponent;
class _DualProperty;
class _Property;
class _Dual_Properties;
class __Properties;
class Properties;
class _Dual_CodeModule;
class __CodeModule;
class CodeModule;
class _Dual_CodePanes;
class __CodePanes;
class CodePanes;
class _Dual_CodePane;
class __CodePane;
class CodePane;
class _Dual_References;
class __References;
class _DualReference;
class _Reference;
class References;

class __stdcall _DualApplication : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetVersion( WBStr * __resultVersion ) = 0;
};

class _Application : public WOleDispatchHelper {

    public:

        _Application();
        ~_Application();

        /* Methods */
        WBString GetVersion( void );

        _Application & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _Application & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualVBE : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetVersion( WBStr * __resultVersion ) = 0;
        virtual WHRESULT GetVBProjects( _Dual_VBProjects * * __resultVBProjects ) = 0;
        virtual WHRESULT GetCommandBars( _DualCommandBars * * __resultCommandBars ) = 0;
        virtual WHRESULT GetCodePanes( _Dual_CodePanes * * __resultCodePanes ) = 0;
        virtual WHRESULT GetWindows( _Dual_Windows * * __resultWindows ) = 0;
        virtual WHRESULT GetEvents( _DualEvents * * __resultEvents ) = 0;
        virtual WHRESULT GetActiveVBProject( _Dual_VBProject * * __resultActiveVBProject ) = 0;
        virtual WHRESULT SetActiveVBProject( _Dual_VBProject const * * __ActiveVBProject ) = 0;
        virtual WHRESULT GetSelectedVBComponent( _Dual_VBComponent * * __resultSelectedVBComponent ) = 0;
        virtual WHRESULT GetMainWindow( _DualWindow * * __resultMainWindow ) = 0;
        virtual WHRESULT GetActiveWindow( _DualWindow * * __resultActiveWindow ) = 0;
        virtual WHRESULT GetActiveCodePane( _Dual_CodePane * * __resultActiveCodePane ) = 0;
        virtual WHRESULT SetActiveCodePane( _Dual_CodePane const * * __ActiveCodePane ) = 0;
};

class _VBE : public WOleDispatchHelper {

    public:

        _VBE();
        ~_VBE();

        /* Methods */
        WBString GetVersion( void );
        _Dual_VBProjects * GetVBProjects( void );
        _DualCommandBars * GetCommandBars( void );
        _Dual_CodePanes * GetCodePanes( void );
        _Dual_Windows * GetWindows( void );
        _DualEvents * GetEvents( void );
        _Dual_VBProject * GetActiveVBProject( void );
        void SetActiveVBProject( _Dual_VBProject const * * __ActiveVBProject );
        _Dual_VBComponent * GetSelectedVBComponent( void );
        _DualWindow * GetMainWindow( void );
        _DualWindow * GetActiveWindow( void );
        _Dual_CodePane * GetActiveCodePane( void );
        void SetActiveCodePane( _Dual_CodePane const * * __ActiveCodePane );

        _VBE & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _VBE & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualWindow : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetCollection( _Dual_Windows * * __resultCollection ) = 0;
        virtual WHRESULT Close( void ) = 0;
        virtual WHRESULT GetCaption( WBStr * __resultCaption ) = 0;
        virtual WHRESULT GetVisible( WVARIANT_BOOL * __resultVisible ) = 0;
        virtual WHRESULT SetVisible( WVARIANT_BOOL __Visible ) = 0;
        virtual WHRESULT GetLeft( long * __resultLeft ) = 0;
        virtual WHRESULT SetLeft( long __Left ) = 0;
        virtual WHRESULT GetTop( long * __resultTop ) = 0;
        virtual WHRESULT SetTop( long __Top ) = 0;
        virtual WHRESULT GetWidth( long * __resultWidth ) = 0;
        virtual WHRESULT SetWidth( long __Width ) = 0;
        virtual WHRESULT GetHeight( long * __resultHeight ) = 0;
        virtual WHRESULT SetHeight( long __Height ) = 0;
        virtual WHRESULT GetWindowState( vbext_WindowState * __resultWindowState ) = 0;
        virtual WHRESULT SetWindowState( vbext_WindowState __WindowState ) = 0;
        virtual WHRESULT SetFocus( void ) = 0;
        virtual WHRESULT GetType( vbext_WindowType * __resultType ) = 0;
        virtual WHRESULT SetKind( vbext_WindowType __eKind ) = 0;
        virtual WHRESULT GetLinkedWindows( _Dual_LinkedWindows * * __resultLinkedWindows ) = 0;
        virtual WHRESULT GetLinkedWindowFrame( _DualWindow * * __resultLinkedWindowFrame ) = 0;
        virtual WHRESULT Detach( void ) = 0;
        virtual WHRESULT Attach( long __lWindowHandle ) = 0;
        virtual WHRESULT GetHWnd( long * __resultHWnd ) = 0;
};

class _Window : public WOleDispatchHelper {

    public:

        _Window();
        ~_Window();

        /* Methods */
        _DualVBE * GetVBE( void );
        _Dual_Windows * GetCollection( void );
        void Close( void );
        WBString GetCaption( void );
        WVARIANT_BOOL GetVisible( void );
        void SetVisible( WVARIANT_BOOL __Visible );
        long GetLeft( void );
        void SetLeft( long __Left );
        long GetTop( void );
        void SetTop( long __Top );
        long GetWidth( void );
        void SetWidth( long __Width );
        long GetHeight( void );
        void SetHeight( long __Height );
        vbext_WindowState GetWindowState( void );
        void SetWindowState( vbext_WindowState __WindowState );
        void SetFocus( void );
        vbext_WindowType GetType( void );
        _Dual_LinkedWindows * GetLinkedWindows( void );
        _DualWindow * GetLinkedWindowFrame( void );

        _Window & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _Window & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _Dual_Windows : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetParent( _DualApplication * * __resultParent ) = 0;
        virtual WHRESULT Item( WVARIANT __index, _DualWindow * * __resultItem ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT _NewEnum( WPIUnknown * __result_NewEnum ) = 0;
};

class __Windows : public WOleDispatchHelper {

    public:

        __Windows();
        ~__Windows();

        /* Methods */
        _DualVBE * GetVBE( void );
        _DualApplication * GetParent( void );
        _DualWindow * Item( WVariant __index );
        long GetCount( void );
        WPIUnknown _NewEnum( void );

        __Windows & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __Windows & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class Windows : public WOleProgrammableObject {

    public:

        Windows();
        ~Windows();

        /* Methods */
        _DualVBE * GetVBE( void );
        _DualApplication * GetParent( void );
        _DualWindow * Item( WVariant __index );
        long GetCount( void );
        WPIUnknown _NewEnum( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_LinkedWindows : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetParent( _DualWindow * * __resultParent ) = 0;
        virtual WHRESULT Item( WVARIANT __index, _DualWindow * * __resultItem ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT _NewEnum( WPIUnknown * __result_NewEnum ) = 0;
        virtual WHRESULT Remove( _DualWindow const * __Window ) = 0;
        virtual WHRESULT Add( _DualWindow const * __Window ) = 0;
};

class __LinkedWindows : public WOleDispatchHelper {

    public:

        __LinkedWindows();
        ~__LinkedWindows();

        /* Methods */
        _DualVBE * GetVBE( void );
        _DualWindow * Item( WVariant __index );
        long GetCount( void );
        WPIUnknown _NewEnum( void );
        void Remove( _DualWindow const * __Window );
        void Add( _DualWindow const * __Window );

        __LinkedWindows & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __LinkedWindows & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class LinkedWindows : public WOleProgrammableObject {

    public:

        LinkedWindows();
        ~LinkedWindows();

        /* Methods */
        _DualVBE * GetVBE( void );
        _DualWindow * Item( WVariant __index );
        long GetCount( void );
        WPIUnknown _NewEnum( void );
        void Remove( _DualWindow const * __Window );
        void Add( _DualWindow const * __Window );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _DualEvents : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetReferencesEvents( _Dual_VBProject const * __VBProject, _ReferencesEvents * * __resultReferencesEvents ) = 0;
        virtual WHRESULT GetCommandBarEvents( WPIDispatch __CommandBarControl, _CommandBarControlEvents * * __resultCommandBarEvents ) = 0;
};

class _Events : public WOleDispatchHelper {

    public:

        _Events();
        ~_Events();

        /* Methods */
        _ReferencesEvents * GetReferencesEvents( _Dual_VBProject const * __VBProject );
        _CommandBarControlEvents * GetCommandBarEvents( WPIDispatch __CommandBarControl );

        _Events & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _Events & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __dispVBProjectsEvents : public WOleDispatchHelper {

    public:

        __dispVBProjectsEvents();
        ~__dispVBProjectsEvents();

        /* Methods */
        void ItemAdded( _Dual_VBProject const * __VBProject );
        void ItemRemoved( _Dual_VBProject const * __VBProject );
        void ItemRenamed( _Dual_VBProject const * __VBProject, WBString __OldName );
        void ItemActivated( _Dual_VBProject const * __VBProject );

        __dispVBProjectsEvents & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __dispVBProjectsEvents & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __dispVBComponentsEvents : public WOleDispatchHelper {

    public:

        __dispVBComponentsEvents();
        ~__dispVBComponentsEvents();

        /* Methods */
        void ItemAdded( _Dual_VBComponent const * __VBComponent );
        void ItemRemoved( _Dual_VBComponent const * __VBComponent );
        void ItemRenamed( _Dual_VBComponent const * __VBComponent, WBString __OldName );
        void ItemSelected( _Dual_VBComponent const * __VBComponent );
        void ItemActivated( _Dual_VBComponent const * __VBComponent );
        void ItemReloaded( _Dual_VBComponent const * __VBComponent );

        __dispVBComponentsEvents & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __dispVBComponentsEvents & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

#define ReferencesEventsItemAddedEvent EventID( "ReferencesEventsItemAdded" )
#define ReferencesEventsItemAddedEventDispID 1
struct ReferencesEventsItemAddedEventData : public WEventData {
    _DualReference const * Reference;
};

#define ReferencesEventsItemRemovedEvent EventID( "ReferencesEventsItemRemoved" )
#define ReferencesEventsItemRemovedEventDispID 2
struct ReferencesEventsItemRemovedEventData : public WEventData {
    _DualReference const * Reference;
};

class ReferencesEvents : public WOleProgrammableObject {

    public:

        ReferencesEvents();
        ~ReferencesEvents();

        /* Events */
        void OnItemAdded( WDispIndex, WDispID, WVariant *, int ); 
        void OnItemRemoved( WDispIndex, WDispID, WVariant *, int ); 

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

#define CommandBarEventsClickEvent EventID( "CommandBarEventsClick" )
#define CommandBarEventsClickEventDispID 1
struct CommandBarEventsClickEventData : public WEventData {
    WPIDispatch CommandBarControl;
    WVARIANT_BOOL const * handled;
    WVARIANT_BOOL const * CancelDefault;
};

class CommandBarEvents : public WOleProgrammableObject {

    public:

        CommandBarEvents();
        ~CommandBarEvents();

        /* Events */
        void OnClick( WDispIndex, WDispID, WVariant *, int ); 

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_VBProject : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( _DualApplication * * __resultApplication ) = 0;
        virtual WHRESULT GetParent( _DualApplication * * __resultParent ) = 0;
        virtual WHRESULT GetHelpFile( WBStr * __resultHelpFile ) = 0;
        virtual WHRESULT SetHelpFile( WBStr __HelpFile ) = 0;
        virtual WHRESULT GetHelpContextID( long * __resultHelpContextID ) = 0;
        virtual WHRESULT SetHelpContextID( long __HelpContextID ) = 0;
        virtual WHRESULT GetDescription( WBStr * __resultDescription ) = 0;
        virtual WHRESULT SetDescription( WBStr __Description ) = 0;
        virtual WHRESULT GetMode( vbext_VBAMode * __resultMode ) = 0;
        virtual WHRESULT GetReferences( _Dual_References * * __resultReferences ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT SetName( WBStr __Name ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetCollection( _Dual_VBProjects * * __resultCollection ) = 0;
        virtual WHRESULT GetProtection( vbext_ProjectProtection * __resultProtection ) = 0;
        virtual WHRESULT GetSaved( WVARIANT_BOOL * __resultSaved ) = 0;
        virtual WHRESULT GetVBComponents( _Dual_VBComponents * * __resultVBComponents ) = 0;
};

class __VBProject : public WOleDispatchHelper {

    public:

        __VBProject();
        ~__VBProject();

        /* Methods */
        WBString GetHelpFile( void );
        void SetHelpFile( WBString __HelpFile );
        long GetHelpContextID( void );
        void SetHelpContextID( long __HelpContextID );
        WBString GetDescription( void );
        void SetDescription( WBString __Description );
        vbext_VBAMode GetMode( void );
        _Dual_References * GetReferences( void );
        WBString GetName( void );
        void SetName( WBString __Name );
        _DualVBE * GetVBE( void );
        _Dual_VBProjects * GetCollection( void );
        vbext_ProjectProtection GetProtection( void );
        WVARIANT_BOOL GetSaved( void );
        _Dual_VBComponents * GetVBComponents( void );

        __VBProject & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __VBProject & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class VBProject : public WOleProgrammableObject {

    public:

        VBProject();
        ~VBProject();

        /* Methods */
        WBString GetHelpFile( void );
        void SetHelpFile( WBString __HelpFile );
        long GetHelpContextID( void );
        void SetHelpContextID( long __HelpContextID );
        WBString GetDescription( void );
        void SetDescription( WBString __Description );
        vbext_VBAMode GetMode( void );
        _Dual_References * GetReferences( void );
        WBString GetName( void );
        void SetName( WBString __Name );
        _DualVBE * GetVBE( void );
        _Dual_VBProjects * GetCollection( void );
        vbext_ProjectProtection GetProtection( void );
        WVARIANT_BOOL GetSaved( void );
        _Dual_VBComponents * GetVBComponents( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_VBProjects : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT Item( WVARIANT __index, _Dual_VBProject * * __resultItem ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetParent( _DualVBE * * __resultParent ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT _NewEnum( WPIUnknown * __result_NewEnum ) = 0;
};

class __VBProjects : public WOleDispatchHelper {

    public:

        __VBProjects();
        ~__VBProjects();

        /* Methods */
        _Dual_VBProject * Item( WVariant __index );
        _DualVBE * GetVBE( void );
        _DualVBE * GetParent( void );
        long GetCount( void );
        WPIUnknown _NewEnum( void );

        __VBProjects & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __VBProjects & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class VBProjects : public WOleProgrammableObject {

    public:

        VBProjects();
        ~VBProjects();

        /* Methods */
        _Dual_VBProject * Item( WVariant __index );
        _DualVBE * GetVBE( void );
        _DualVBE * GetParent( void );
        long GetCount( void );
        WPIUnknown _NewEnum( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_VBComponents : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT Item( WVARIANT __index, _Dual_VBComponent * * __resultItem ) = 0;
        virtual WHRESULT GetParent( _Dual_VBProject * * __resultParent ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT _NewEnum( WPIUnknown * __result_NewEnum ) = 0;
        virtual WHRESULT Remove( _Dual_VBComponent const * __VBComponent ) = 0;
        virtual WHRESULT Add( vbext_ComponentType __ComponentType, _Dual_VBComponent * * __resultAdd ) = 0;
        virtual WHRESULT Import( WBStr __FileName, _Dual_VBComponent * * __resultImport ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
};

class __VBComponents : public WOleDispatchHelper {

    public:

        __VBComponents();
        ~__VBComponents();

        /* Methods */
        _Dual_VBComponent * Item( WVariant __index );
        _Dual_VBProject * GetParent( void );
        long GetCount( void );
        WPIUnknown _NewEnum( void );
        void Remove( _Dual_VBComponent const * __VBComponent );
        _Dual_VBComponent * Add( vbext_ComponentType __ComponentType );
        _Dual_VBComponent * Import( WBString __FileName );
        _DualVBE * GetVBE( void );

        __VBComponents & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __VBComponents & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class VBComponents : public WOleProgrammableObject {

    public:

        VBComponents();
        ~VBComponents();

        /* Methods */
        _Dual_VBComponent * Item( WVariant __index );
        _Dual_VBProject * GetParent( void );
        long GetCount( void );
        WPIUnknown _NewEnum( void );
        void Remove( _Dual_VBComponent const * __VBComponent );
        _Dual_VBComponent * Add( vbext_ComponentType __ComponentType );
        _Dual_VBComponent * Import( WBString __FileName );
        _DualVBE * GetVBE( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_VBComponent : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetSaved( WVARIANT_BOOL * __resultSaved ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT SetName( WBStr __Name ) = 0;
        virtual WHRESULT GetDesigner( WPIDispatch * __resultDesigner ) = 0;
        virtual WHRESULT GetCodeModule( _Dual_CodeModule * * __resultCodeModule ) = 0;
        virtual WHRESULT GetType( vbext_ComponentType * __resultType ) = 0;
        virtual WHRESULT Export( WBStr __FileName ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetCollection( _Dual_VBComponents * * __resultCollection ) = 0;
        virtual WHRESULT GetHasOpenDesigner( WVARIANT_BOOL * __resultHasOpenDesigner ) = 0;
        virtual WHRESULT GetProperties( _Dual_Properties * * __resultProperties ) = 0;
        virtual WHRESULT DesignerWindow( _DualWindow * * __resultDesignerWindow ) = 0;
        virtual WHRESULT Activate( void ) = 0;
};

class __VBComponent : public WOleDispatchHelper {

    public:

        __VBComponent();
        ~__VBComponent();

        /* Methods */
        WVARIANT_BOOL GetSaved( void );
        WBString GetName( void );
        void SetName( WBString __Name );
        WPIDispatch GetDesigner( void );
        _Dual_CodeModule * GetCodeModule( void );
        vbext_ComponentType GetType( void );
        void Export( WBString __FileName );
        _DualVBE * GetVBE( void );
        _Dual_VBComponents * GetCollection( void );
        WVARIANT_BOOL GetHasOpenDesigner( void );
        _Dual_Properties * GetProperties( void );
        _DualWindow * DesignerWindow( void );
        void Activate( void );

        __VBComponent & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __VBComponent & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class VBComponent : public WOleProgrammableObject {

    public:

        VBComponent();
        ~VBComponent();

        /* Methods */
        WVARIANT_BOOL GetSaved( void );
        WBString GetName( void );
        void SetName( WBString __Name );
        WPIDispatch GetDesigner( void );
        _Dual_CodeModule * GetCodeModule( void );
        vbext_ComponentType GetType( void );
        void Export( WBString __FileName );
        _DualVBE * GetVBE( void );
        _Dual_VBComponents * GetCollection( void );
        WVARIANT_BOOL GetHasOpenDesigner( void );
        _Dual_Properties * GetProperties( void );
        _DualWindow * DesignerWindow( void );
        void Activate( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _DualProperty : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetValue( WVARIANT * __resultValue ) = 0;
        virtual WHRESULT SetValue( WVARIANT __Value ) = 0;
        virtual WHRESULT GetIndexedValue( WVARIANT __Index1, WVARIANT __Index2=WVariant(), WVARIANT __Index3=WVariant(), WVARIANT __Index4=WVariant(), WVARIANT * __resultIndexedValue=NULL ) = 0;
        virtual WHRESULT SetIndexedValue( WVARIANT __Index1, WVARIANT __Index2, WVARIANT __Index3=WVariant(), WVARIANT __Index4=WVariant(), WVARIANT __IndexedValue=WVariant() ) = 0;
        virtual WHRESULT GetNumIndices( short * __resultNumIndices ) = 0;
        virtual WHRESULT GetApplication( _DualApplication * * __resultApplication ) = 0;
        virtual WHRESULT GetParent( _Dual_Properties * * __resultParent ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetCollection( _Dual_Properties * * __resultCollection ) = 0;
        virtual WHRESULT GetObject( WPIUnknown * __resultObject ) = 0;
        virtual WHRESULT SetObject( WPIUnknown * __Object ) = 0;
};

class _Property : public WOleDispatchHelper {

    public:

        _Property();
        ~_Property();

        /* Methods */
        WVariant GetValue( void );
        void SetValue( WVariant __Value );
        WVariant GetIndexedValue( WVariant __Index1, WVariant __Index2=WVariant(), WVariant __Index3=WVariant(), WVariant __Index4=WVariant() );
        void SetIndexedValue( WVariant __Index1, WVariant __Index2, WVariant __Index3=WVariant(), WVariant __Index4=WVariant(), WVariant __IndexedValue=WVariant() );
        short GetNumIndices( void );
        WBString GetName( void );
        _DualVBE * GetVBE( void );
        _Dual_Properties * GetCollection( void );
        WPIUnknown GetObject( void );
        void SetObject( WPIUnknown * __Object );

        _Property & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _Property & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _Dual_Properties : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT Item( WVARIANT __index, _DualProperty * * __resultItem ) = 0;
        virtual WHRESULT GetApplication( _DualApplication * * __resultApplication ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT _NewEnum( WPIUnknown * __result_NewEnum ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
};

class __Properties : public WOleDispatchHelper {

    public:

        __Properties();
        ~__Properties();

        /* Methods */
        _DualProperty * Item( WVariant __index );
        WPIDispatch GetParent( void );
        long GetCount( void );
        WPIUnknown _NewEnum( void );
        _DualVBE * GetVBE( void );

        __Properties & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __Properties & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class Properties : public WOleProgrammableObject {

    public:

        Properties();
        ~Properties();

        /* Methods */
        _DualProperty * Item( WVariant __index );
        WPIDispatch GetParent( void );
        long GetCount( void );
        WPIUnknown _NewEnum( void );
        _DualVBE * GetVBE( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_CodeModule : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetParent( _Dual_VBComponent * * __resultParent ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT SetName( WBStr __Name ) = 0;
        virtual WHRESULT AddFromString( WBStr __String ) = 0;
        virtual WHRESULT AddFromFile( WBStr __FileName ) = 0;
        virtual WHRESULT GetLines( long __StartLine, long __Count, WBStr * __resultLines ) = 0;
        virtual WHRESULT GetCountOfLines( long * __resultCountOfLines ) = 0;
        virtual WHRESULT InsertLines( long __Line, WBStr __String ) = 0;
        virtual WHRESULT DeleteLines( long __StartLine, long __Count=1 ) = 0;
        virtual WHRESULT ReplaceLine( long __Line, WBStr __String ) = 0;
        virtual WHRESULT GetProcStartLine( WBStr __ProcName, vbext_ProcKind __ProcKind, long * __resultProcStartLine ) = 0;
        virtual WHRESULT GetProcCountLines( WBStr __ProcName, vbext_ProcKind __ProcKind, long * __resultProcCountLines ) = 0;
        virtual WHRESULT GetProcBodyLine( WBStr __ProcName, vbext_ProcKind __ProcKind, long * __resultProcBodyLine ) = 0;
        virtual WHRESULT GetProcOfLine( long __Line, vbext_ProcKind * __ProcKind, WBStr * __resultProcOfLine ) = 0;
        virtual WHRESULT GetCountOfDeclarationLines( long * __resultCountOfDeclarationLines ) = 0;
        virtual WHRESULT CreateEventProc( WBStr __EventName, WBStr __ObjectName, long * __resultCreateEventProc ) = 0;
        virtual WHRESULT Find( WBStr __Target, long * __StartLine, long * __StartColumn, long * __EndLine, long * __EndColumn, WVARIANT_BOOL __WholeWord=0, WVARIANT_BOOL __MatchCase=0, WVARIANT_BOOL __PatternSearch=0
            , WVARIANT_BOOL * __resultFind=NULL ) = 0;
        virtual WHRESULT GetCodePane( _Dual_CodePane * * __resultCodePane ) = 0;
};

class __CodeModule : public WOleDispatchHelper {

    public:

        __CodeModule();
        ~__CodeModule();

        /* Methods */
        _Dual_VBComponent * GetParent( void );
        _DualVBE * GetVBE( void );
        void AddFromString( WBString __String );
        void AddFromFile( WBString __FileName );
        WBString GetLines( long __StartLine, long __Count );
        long GetCountOfLines( void );
        void InsertLines( long __Line, WBString __String );
        void DeleteLines( long __StartLine, long __Count=1 );
        void ReplaceLine( long __Line, WBString __String );
        long GetProcStartLine( WBString __ProcName, vbext_ProcKind __ProcKind );
        long GetProcCountLines( WBString __ProcName, vbext_ProcKind __ProcKind );
        long GetProcBodyLine( WBString __ProcName, vbext_ProcKind __ProcKind );
        WBString GetProcOfLine( long __Line, vbext_ProcKind * __ProcKind );
        long GetCountOfDeclarationLines( void );
        long CreateEventProc( WBString __EventName, WBString __ObjectName );
        WVARIANT_BOOL Find( WBString __Target, long * __StartLine, long * __StartColumn, long * __EndLine, long * __EndColumn, WVARIANT_BOOL __WholeWord=0, WVARIANT_BOOL __MatchCase=0, WVARIANT_BOOL __PatternSearch=0 );
        _Dual_CodePane * GetCodePane( void );

        __CodeModule & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __CodeModule & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class CodeModule : public WOleProgrammableObject {

    public:

        CodeModule();
        ~CodeModule();

        /* Methods */
        _Dual_VBComponent * GetParent( void );
        _DualVBE * GetVBE( void );
        void AddFromString( WBString __String );
        void AddFromFile( WBString __FileName );
        WBString GetLines( long __StartLine, long __Count );
        long GetCountOfLines( void );
        void InsertLines( long __Line, WBString __String );
        void DeleteLines( long __StartLine, long __Count=1 );
        void ReplaceLine( long __Line, WBString __String );
        long GetProcStartLine( WBString __ProcName, vbext_ProcKind __ProcKind );
        long GetProcCountLines( WBString __ProcName, vbext_ProcKind __ProcKind );
        long GetProcBodyLine( WBString __ProcName, vbext_ProcKind __ProcKind );
        WBString GetProcOfLine( long __Line, vbext_ProcKind * __ProcKind );
        long GetCountOfDeclarationLines( void );
        long CreateEventProc( WBString __EventName, WBString __ObjectName );
        WVARIANT_BOOL Find( WBString __Target, long * __StartLine, long * __StartColumn, long * __EndLine, long * __EndColumn, WVARIANT_BOOL __WholeWord=0, WVARIANT_BOOL __MatchCase=0, WVARIANT_BOOL __PatternSearch=0 );
        _Dual_CodePane * GetCodePane( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_CodePanes : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetParent( _DualVBE * * __resultParent ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT Item( WVARIANT __index, _Dual_CodePane * * __resultItem ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT _NewEnum( WPIUnknown * __result_NewEnum ) = 0;
        virtual WHRESULT GetCurrent( _Dual_CodePane * * __resultCurrent ) = 0;
        virtual WHRESULT SetCurrent( _Dual_CodePane const * __Current ) = 0;
};

class __CodePanes : public WOleDispatchHelper {

    public:

        __CodePanes();
        ~__CodePanes();

        /* Methods */
        _DualVBE * GetParent( void );
        _DualVBE * GetVBE( void );
        _Dual_CodePane * Item( WVariant __index );
        long GetCount( void );
        WPIUnknown _NewEnum( void );

        __CodePanes & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __CodePanes & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class CodePanes : public WOleProgrammableObject {

    public:

        CodePanes();
        ~CodePanes();

        /* Methods */
        _DualVBE * GetParent( void );
        _DualVBE * GetVBE( void );
        _Dual_CodePane * Item( WVariant __index );
        long GetCount( void );
        WPIUnknown _NewEnum( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_CodePane : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetCollection( _Dual_CodePanes * * __resultCollection ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetWindow( _DualWindow * * __resultWindow ) = 0;
        virtual WHRESULT GetSelection( long * __StartLine, long * __StartColumn, long * __EndLine, long * __EndColumn ) = 0;
        virtual WHRESULT SetSelection( long __StartLine, long __StartColumn, long __EndLine, long __EndColumn ) = 0;
        virtual WHRESULT GetTopLine( long * __resultTopLine ) = 0;
        virtual WHRESULT SetTopLine( long __TopLine ) = 0;
        virtual WHRESULT GetCountOfVisibleLines( long * __resultCountOfVisibleLines ) = 0;
        virtual WHRESULT GetCodeModule( _Dual_CodeModule * * __resultCodeModule ) = 0;
        virtual WHRESULT Show( void ) = 0;
        virtual WHRESULT GetCodePaneView( vbext_CodePaneview * __resultCodePaneView ) = 0;
};

class __CodePane : public WOleDispatchHelper {

    public:

        __CodePane();
        ~__CodePane();

        /* Methods */
        _Dual_CodePanes * GetCollection( void );
        _DualVBE * GetVBE( void );
        _DualWindow * GetWindow( void );
        void GetSelection( long * __StartLine, long * __StartColumn, long * __EndLine, long * __EndColumn );
        void SetSelection( long __StartLine, long __StartColumn, long __EndLine, long __EndColumn );
        long GetTopLine( void );
        void SetTopLine( long __TopLine );
        long GetCountOfVisibleLines( void );
        _Dual_CodeModule * GetCodeModule( void );
        void Show( void );
        vbext_CodePaneview GetCodePaneView( void );

        __CodePane & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __CodePane & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class CodePane : public WOleProgrammableObject {

    public:

        CodePane();
        ~CodePane();

        /* Methods */
        _Dual_CodePanes * GetCollection( void );
        _DualVBE * GetVBE( void );
        _DualWindow * GetWindow( void );
        void GetSelection( long * __StartLine, long * __StartColumn, long * __EndLine, long * __EndColumn );
        void SetSelection( long __StartLine, long __StartColumn, long __EndLine, long __EndColumn );
        long GetTopLine( void );
        void SetTopLine( long __TopLine );
        long GetCountOfVisibleLines( void );
        _Dual_CodeModule * GetCodeModule( void );
        void Show( void );
        vbext_CodePaneview GetCodePaneView( void );

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

class __stdcall _Dual_References : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetParent( _Dual_VBProject * * __resultParent ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT Item( WVARIANT __index, _DualReference * * __resultItem ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT _NewEnum( WPIUnknown * __result_NewEnum ) = 0;
        virtual WHRESULT AddFromGuid( WBStr __Guid, long __Major, long __Minor, _DualReference * * __resultAddFromGuid ) = 0;
        virtual WHRESULT AddFromFile( WBStr __FileName, _DualReference * * __resultAddFromFile ) = 0;
        virtual WHRESULT Remove( _DualReference const * __Reference ) = 0;
};

class __References : public WOleDispatchHelper {

    public:

        __References();
        ~__References();

        /* Methods */
        _Dual_VBProject * GetParent( void );
        _DualVBE * GetVBE( void );
        _DualReference * Item( WVariant __index );
        long GetCount( void );
        WPIUnknown _NewEnum( void );
        _DualReference * AddFromGuid( WBString __Guid, long __Major, long __Minor );
        _DualReference * AddFromFile( WBString __FileName );
        void Remove( _DualReference const * __Reference );

        __References & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        __References & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualReference : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetCollection( _Dual_References * * __resultCollection ) = 0;
        virtual WHRESULT GetVBE( _DualVBE * * __resultVBE ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT GetGuid( WBStr * __resultGuid ) = 0;
        virtual WHRESULT GetMajor( long * __resultMajor ) = 0;
        virtual WHRESULT GetMinor( long * __resultMinor ) = 0;
        virtual WHRESULT GetFullPath( WBStr * __resultFullPath ) = 0;
        virtual WHRESULT GetBuiltIn( WVARIANT_BOOL * __resultBuiltIn ) = 0;
        virtual WHRESULT GetIsBroken( WVARIANT_BOOL * __resultIsBroken ) = 0;
        virtual WHRESULT GetType( vbext_RefKind * __resultType ) = 0;
        virtual WHRESULT GetDescription( WBStr * __resultDescription ) = 0;
};

class _Reference : public WOleDispatchHelper {

    public:

        _Reference();
        ~_Reference();

        /* Methods */
        _Dual_References * GetCollection( void );
        _DualVBE * GetVBE( void );
        WBString GetName( void );
        WBString GetGuid( void );
        long GetMajor( void );
        long GetMinor( void );
        WBString GetFullPath( void );
        WVARIANT_BOOL GetBuiltIn( void );
        WVARIANT_BOOL GetIsBroken( void );
        vbext_RefKind GetType( void );
        WBString GetDescription( void );

        _Reference & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _Reference & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

#define ReferencesItemAddedEvent EventID( "ReferencesItemAdded" )
#define ReferencesItemAddedEventDispID 0
struct ReferencesItemAddedEventData : public WEventData {
    _DualReference * Reference;
};

#define ReferencesItemRemovedEvent EventID( "ReferencesItemRemoved" )
#define ReferencesItemRemovedEventDispID 1
struct ReferencesItemRemovedEventData : public WEventData {
    _DualReference * Reference;
};

class References : public WOleProgrammableObject {

    public:

        References();
        ~References();

        /* Methods */
        _Dual_VBProject * GetParent( void );
        _DualVBE * GetVBE( void );
        _DualReference * Item( WVariant __index );
        long GetCount( void );
        WPIUnknown _NewEnum( void );
        _DualReference * AddFromGuid( WBString __Guid, long __Major, long __Minor );
        _DualReference * AddFromFile( WBString __FileName );
        void Remove( _DualReference const * __Reference );

        /* Events */
        void OnItemAdded( WDispIndex, WDispID, WVariant *, int ); 
        void OnItemRemoved( WDispIndex, WDispID, WVariant *, int ); 

    private:

        const WChar * GetRegisteredClass();

    private:

        WString     _clsid;
};

#pragma warning 849 4 // restore to previous warning level

#endif
